Index: trunk/VUT/doc/SciReport/Bib/new.bib
===================================================================
--- trunk/VUT/doc/SciReport/Bib/new.bib	(revision 251)
+++ trunk/VUT/doc/SciReport/Bib/new.bib	(revision 277)
@@ -1,2 +1,117 @@
+@Article{avis96,
+  author = "David Avis and Komei Fukuda",
+  title = "Reverse Search for Enumeration",
+  journal =  "Discrete Applied Mathematics",
+  year = "1996",
+  volume = "6",
+  pages = "21--46"
+}
+
+@Article{Fukuda:1996:DDM,
+  author =       "K. Fukuda and A. Prodon",
+  title =        "Double Description Method Revisited",
+  journal =      "Lecture Notes in Computer Science",
+  volume =       "1120",
+  pages =        "91--111",
+  year =         "1996",
+  coden =        "LNCSD9",
+  ISSN =         "0302-9743",
+  bibdate =      "Mon Aug 25 16:23:54 MDT 1997",
+  acknowledgement = ack-nhfb,
+}
+
+@Misc{lrs_site,
+  author = 	 {David Avis},
+  title  = 	 {LRS polyhedra enumeration library},
+  year   =       {2002},
+  note    = 	 "Available at \url{http://cgm.cs.mcgill.ca/~avis/C/lrs.html}",
+}
+
+@InProceedings{buehler2001,
+  pages =        "425--432",
+  year =         "2001",
+  title =        "Unstructured Lumigraph Rendering",
+  author =       "Chris Buehler and Michael Bosse and Leonard McMillan
+                 and Steven J. Gortler and Michael F. Cohen",
+  abstract =     "We describe an image based rendering approach that
+                 generalizes many current image based rendering
+                 algorithms, including light field rendering and
+                 view-dependent texture mapping. In particular, it
+                 allows for lumigraph-style rendering from a set of
+                 input cameras in arbitrary configurations (i.e., not
+                 restricted to a plane or to any specific manifold). In
+                 the case of regular and planar input camera positions,
+                 our algorithm reduces to a typical lumigraph approach.
+                 When presented with fewer cameras and good approximate
+                 geometry, our algorithm behaves like view-dependent
+                 texture mapping. The algorithm achieves this
+                 flexibility because it is designed to meet a set of
+                 specific goals that we describe. We demonstrate this
+                 flexibility with a variety of examples.",
+  keywords =     "Image-Based Rendering",
+  booktitle =    "Computer Graphics (SIGGRAPH '01 Proceedings)",
+}
+
+@InProceedings{haumont2005:egsr,
+  pages =        "211--222",
+  year =         "2005",
+  title =        "A Low Dimensional Framework for Exact Polygon-to-Polygon Occlusion Queries",
+  author =       {Denis Haumont and Otso M\"{a}kinen and Shaun Nirenstein},
+  booktitle =    "Proceedings of Eurographics Symposium on Rendering",
+}
+
+
+
+@InProceedings{Sadagic,
+  pages =        "111--122",
+  year =         "2000",
+  title =        "Dynamic Polygon Visibility Ordering for Head-Slaved
+                 Viewing in Virtual Environments",
+  author =       "Amela Sadagic and Mel Slater",
+  url =          "http://visinfo.zib.de/EVlib/Show?EVL-2000-336",
+  abstract =     "This paper presents an approach to visibility called
+                 the Viewpoint Movement Space (VpMS) algorithm which
+                 supports the concept of dynamic polygon visibility
+                 orderings for head-slaved viewing in virtual
+                 environments (VE). The central idea of the approach is
+                 that the visibility, in terms of back-to-front polygon
+                 visibility ordering, does not change dramatically as
+                 the viewpoint moves. Moreover, it is possible to
+                 construct a partition of the space into cells, where
+                 for each cell the ordering is invariant. As the
+                 viewpoint moves across a cell boundary typically only a
+                 small and predictable change is made to the visibility
+                 ordering. The cost to perform this operation represents
+                 a notable reduction when compared with the cost of
+                 resolving the visibility information from the BSP tree
+                 where the classification of the viewpoint with every
+                 node plane has to be performed. The paper demonstrates
+                 how the subdivision into such cells can represent the
+                 basic source for an acceleration of the rendering
+                 process. We also discuss how the same supportive data
+                 structure can be exploited to solve other tasks in the
+                 graphics pipeline.",
+  organization = "Eurographics Association",
+  volume =       "19(2)",
+  booktitle =    "Computer Graphics Forum",
+}
+
+@Book{dcg-handbook,
+  title =        "Handbook of Discrete and Computational Geometry",
+  booktitle =    "Handbook of Discrete and Computational Geometry",
+  publisher =    "CRC Press",
+  year =         "1997",
+  editor =       "Jacob E. Goodman and Joseph O'Rourke",
+}
+
+@PhdThesis{Pu98-DSGIV,
+  author =       "Fan-Tao Pu",
+  year =         "1998",
+  title =        "Data Structures for Global Illumination and Visibility
+                 Queries in 3-Space",
+  address =      "College Park, MD",
+  school =       "University of Maryland",
+}
+
 @TechReport{Hillesland02,
   author =       "Karl Hillesland and Brian Salomon and Anselmo Lastra
Index: trunk/VUT/doc/SciReport/Bib/jiri.bib
===================================================================
--- trunk/VUT/doc/SciReport/Bib/jiri.bib	(revision 243)
+++ trunk/VUT/doc/SciReport/Bib/jiri.bib	(revision 277)
@@ -1,2 +1,11 @@
+@Article{wimmer05:gpugems,
+  author = 	 {Michael Wimmer and Ji\v{r}\'\i{} Bittner},
+  title = 	 {Hardware Occlusion Queries Made Useful},
+  journal = 	 {GPU Gems 2: Programming Techniques for High-Performance Graphics and General-Purpose Computation},
+  year = 	 {2005},
+  pages = 	 {91--108},
+  publisher = {Addison Wesley}
+}
+
 @Article{bittner03:jep,
   author = 	 {Ji\v{r}\'\i{} Bittner and Peter Wonka},
@@ -12,5 +21,5 @@
 
 
-@PhdThesis{bittner:03:phd,
+@PhdThesis{bittner:02:phd,
   author = 	 {Ji\v{r}\'\i{} Bittner},
   title = 	 {Hierarchical Techniques for Visibility Computations},