Index: /trunk/VUT/doc/SciReport/figs/viewcell_part.eps
===================================================================
--- /trunk/VUT/doc/SciReport/figs/viewcell_part.eps	(revision 279)
+++ /trunk/VUT/doc/SciReport/figs/viewcell_part.eps	(revision 280)
@@ -3,6 +3,6 @@
 %%Pages: 1
 %%Orientation: Portrait
-%%BoundingBox: 37 267 523 565
-%%HiResBoundingBox: 37.335752 267.56784 522.26021 564.43232
+%%BoundingBox: 35 275 523 541
+%%HiResBoundingBox: 35.315479 275.24539 522.26021 540.92724
 %%EndComments
 %%Page: 1 1
@@ -10,13 +10,39 @@
 0.80000000 -0.80000000 scale
 gsave [1.0000000 0.00000000 0.00000000 1.0000000 0.00000000 0.00000000] concat
+gsave [0.65975900 0.75147700 -0.75147700 0.65975900 0.00000000 0.00000000] concat
+gsave
+0.00000000 1.0000000 0.00000000 setrgbcolor
+newpath
+596.52661 147.99750 moveto
+674.47675 147.99750 lineto
+674.47675 161.34754 lineto
+596.52661 161.34754 lineto
+596.52661 147.99750 lineto
+closepath
+fill
+grestore
+0.00000000 1.0000000 0.00000000 setrgbcolor
+[] 0 setdash
+1.9800013 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+596.52661 147.99750 moveto
+674.47675 147.99750 lineto
+674.47675 161.34754 lineto
+596.52661 161.34754 lineto
+596.52661 147.99750 lineto
+closepath
+stroke
+grestore
 gsave [0.92330700 0.38406300 -0.40401100 0.91475400 0.00000000 0.00000000] concat
 gsave
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
-287.61404 505.38336 moveto
-319.90598 505.38336 lineto
-319.90598 541.13936 lineto
-287.61404 541.13936 lineto
-287.61404 505.38336 lineto
+303.67282 548.33398 moveto
+335.96476 548.33398 lineto
+335.96476 584.08998 lineto
+303.67282 584.08998 lineto
+303.67282 548.33398 lineto
 closepath
 eofill
@@ -28,9 +54,9 @@
 0 setlinecap
 newpath
-287.61404 505.38336 moveto
-319.90598 505.38336 lineto
-319.90598 541.13936 lineto
-287.61404 541.13936 lineto
-287.61404 505.38336 lineto
+303.67282 548.33398 moveto
+335.96476 548.33398 lineto
+335.96476 584.08998 lineto
+303.67282 584.08998 lineto
+303.67282 548.33398 lineto
 closepath
 stroke
@@ -79,23 +105,23 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
-584.23883 409.96259 moveto
-615.52145 409.96259 lineto
-615.52145 442.59405 lineto
-584.23883 442.59405 lineto
-584.23883 409.96259 lineto
-closepath
-eofill
-grestore
-0.00000000 0.00000000 1.0000000 setrgbcolor
-[] 0 setdash
-0.75914425 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-584.23883 409.96259 moveto
-615.52145 409.96259 lineto
-615.52145 442.59405 lineto
-584.23883 442.59405 lineto
-584.23883 409.96259 lineto
+456.42810 476.06787 moveto
+487.71068 476.06787 lineto
+487.71068 508.69933 lineto
+456.42810 508.69933 lineto
+456.42810 476.06787 lineto
+closepath
+eofill
+grestore
+0.00000000 0.00000000 1.0000000 setrgbcolor
+[] 0 setdash
+0.75914371 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+456.42810 476.06787 moveto
+487.71068 476.06787 lineto
+487.71068 508.69933 lineto
+456.42810 508.69933 lineto
+456.42810 476.06787 lineto
 closepath
 stroke
@@ -105,9 +131,9 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
--351.29410 262.34665 moveto
--321.37732 262.34665 lineto
--321.37732 309.43711 lineto
--351.29410 309.43711 lineto
--351.29410 262.34665 lineto
+-344.38599 376.22754 moveto
+-324.36791 376.22754 lineto
+-324.36791 398.24718 lineto
+-344.38599 398.24718 lineto
+-344.38599 376.22754 lineto
 closepath
 eofill
@@ -119,9 +145,9 @@
 0 setlinecap
 newpath
--351.29410 262.34665 moveto
--321.37732 262.34665 lineto
--321.37732 309.43711 lineto
--351.29410 309.43711 lineto
--351.29410 262.34665 lineto
+-344.38599 376.22754 moveto
+-324.36791 376.22754 lineto
+-324.36791 398.24718 lineto
+-344.38599 398.24718 lineto
+-344.38599 376.22754 lineto
 closepath
 stroke
@@ -153,27 +179,27 @@
 stroke
 grestore
-gsave [0.77036100 0.63760800 -0.63760800 0.77036100 0.00000000 0.00000000] concat
-gsave
-0.00000000 0.00000000 1.0000000 setrgbcolor
-newpath
-339.16025 170.14166 moveto
-376.88016 170.14166 lineto
-376.88016 197.94212 lineto
-339.16025 197.94212 lineto
-339.16025 170.14166 lineto
-closepath
-eofill
-grestore
-0.00000000 0.00000000 1.0000000 setrgbcolor
-[] 0 setdash
-1.0000000 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-339.16025 170.14166 moveto
-376.88016 170.14166 lineto
-376.88016 197.94212 lineto
-339.16025 197.94212 lineto
-339.16025 170.14166 lineto
+gsave [0.83383200 -0.55201900 0.55201900 0.83383200 0.00000000 0.00000000] concat
+gsave
+0.00000000 0.00000000 1.0000000 setrgbcolor
+newpath
+2.4339151 475.15820 moveto
+28.936269 475.15820 lineto
+28.936269 492.57411 lineto
+2.4339151 492.57411 lineto
+2.4339151 475.15820 lineto
+closepath
+eofill
+grestore
+0.00000000 0.00000000 1.0000000 setrgbcolor
+[] 0 setdash
+1.0000011 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+2.4339151 475.15820 moveto
+28.936269 475.15820 lineto
+28.936269 492.57411 lineto
+2.4339151 492.57411 lineto
+2.4339151 475.15820 lineto
 closepath
 stroke
@@ -183,5 +209,5 @@
 newpath
 484.25220 603.90547 moveto
-97.324430 593.80394 lineto
+94.799049 638.75573 lineto
 eofill
 grestore
@@ -193,7 +219,7 @@
 newpath
 484.25220 603.90547 moveto
-97.324430 593.80394 lineto
-stroke
-gsave [1.1875603 0.031003658 -0.031003658 1.1875603 91.386628 593.64892] concat
+94.799049 638.75573 lineto
+stroke
+gsave [1.1832370 -0.10588210 0.10588210 1.1832370 88.882864 639.28514] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -211,5 +237,5 @@
 newpath
 485.35699 601.97099 moveto
-179.05211 389.66730 lineto
+294.71457 406.33482 lineto
 eofill
 grestore
@@ -221,7 +247,7 @@
 newpath
 485.35699 601.97099 moveto
-179.05211 389.66730 lineto
-stroke
-gsave [0.85046095 0.58946497 -0.58946497 0.85046095 174.79981 386.71998] concat
+294.71457 406.33482 lineto
+stroke
+gsave [0.72217462 0.74109149 -0.74109149 0.72217462 291.10370 402.62936] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -239,5 +265,5 @@
 newpath
 485.72819 599.38017 moveto
-242.32054 399.32919 lineto
+334.24442 405.39011 lineto
 eofill
 grestore
@@ -249,7 +275,7 @@
 newpath
 485.72819 599.38017 moveto
-242.32054 399.32919 lineto
-stroke
-gsave [0.86400001 0.71010113 -0.71010113 0.86400001 238.00054 395.77868] concat
+334.24442 405.39011 lineto
+stroke
+gsave [0.68831432 0.88145507 -0.88145507 0.68831432 330.80285 400.98283] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -263,64 +289,4 @@
 grestore
 grestore
-gsave
-0.00000000 0.00000000 0.00000000 setrgbcolor
-newpath
-292.30355 681.68721 moveto
-92.293330 609.96638 lineto
-eofill
-grestore
-0.00000000 0.00000000 0.00000000 setrgbcolor
-[] 0 setdash
-1.9250000 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-292.30355 681.68721 moveto
-92.293330 609.96638 lineto
-stroke
-gsave [1.0872141 0.38985956 -0.38985956 1.0872141 86.857260 608.01708] concat
-gsave
-0.00000000 0.00000000 0.00000000 setrgbcolor
-newpath
-8.7185878 4.0337352 moveto
--2.2072895 0.016013256 lineto
-8.7185884 -4.0017078 lineto
-6.9730900 -1.6296469 6.9831476 1.6157441 8.7185878 4.0337352 curveto
-closepath
-eofill
-grestore
-grestore
-gsave
-0.00000000 0.00000000 1.0000000 setrgbcolor
-newpath
-99.364400 490.80371 moveto
-409.98630 570.53512 lineto
-eofill
-grestore
-0.00000000 0.00000000 1.0000000 setrgbcolor
-[2.8250000 2.8250000] 0.00000000 setdash
-2.8250000 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-99.364400 490.80371 moveto
-409.98630 570.53512 lineto
-stroke
-gsave
-1.0000000 0.00000000 0.00000000 setrgbcolor
-newpath
-352.91269 418.03740 moveto
-270.08018 687.74813 lineto
-eofill
-grestore
-1.0000000 0.00000000 0.00000000 setrgbcolor
-[11.300000 11.300000] 1.4125000 setdash
-2.8250000 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-352.91269 418.03740 moveto
-270.08018 687.74813 lineto
-stroke
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -1062,4 +1028,83 @@
 651.41276 431.16939 lineto
 stroke
+gsave [0.74322500 0.66904200 -0.66904200 0.74322500 0.00000000 0.00000000] concat
+gsave
+0.00000000 1.0000000 0.00000000 setrgbcolor
+newpath
+517.90771 149.53259 moveto
+695.34373 149.53259 lineto
+695.34373 161.73132 lineto
+517.90771 161.73132 lineto
+517.90771 149.53259 lineto
+closepath
+fill
+grestore
+0.00000000 1.0000000 0.00000000 setrgbcolor
+[] 0 setdash
+2.1927264 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+517.90771 149.53259 moveto
+695.34373 149.53259 lineto
+695.34373 161.73132 lineto
+517.90771 161.73132 lineto
+517.90771 149.53259 lineto
+closepath
+stroke
+grestore
+gsave
+1.0000000 0.00000000 0.00000000 setrgbcolor
+newpath
+352.91269 418.03740 moveto
+270.08018 687.74813 lineto
+eofill
+grestore
+1.0000000 0.00000000 0.00000000 setrgbcolor
+[11.300000 11.300000] 1.4125000 setdash
+2.8250000 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+352.91269 418.03740 moveto
+270.08018 687.74813 lineto
+stroke
+0.00000000 0.00000000 0.00000000 setrgbcolor
+[] 0 setdash
+1.9800000 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+480.32753 607.38999 moveto
+190.41376 670.52452 lineto
+stroke
+gsave [1.1607942 -0.25278619 0.25278619 1.1607942 184.60979 671.78845] concat
+gsave
+0.00000000 0.00000000 0.00000000 setrgbcolor
+newpath
+8.7185878 4.0337352 moveto
+-2.2072895 0.016013256 lineto
+8.7185884 -4.0017078 lineto
+6.9730900 -1.6296469 6.9831476 1.6157441 8.7185878 4.0337352 curveto
+closepath
+eofill
+grestore
+grestore
+gsave
+0.00000000 0.00000000 1.0000000 setrgbcolor
+newpath
+99.364400 490.80371 moveto
+409.98630 570.53512 lineto
+eofill
+grestore
+0.00000000 0.00000000 1.0000000 setrgbcolor
+[2.8250000 2.8250000] 0.00000000 setdash
+2.8250000 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+99.364400 490.80371 moveto
+409.98630 570.53512 lineto
+stroke
 grestore
 showpage