Index: trunk/VUT/doc/SciReport/figs/viewcell_part.eps
===================================================================
--- trunk/VUT/doc/SciReport/figs/viewcell_part.eps	(revision 280)
+++ trunk/VUT/doc/SciReport/figs/viewcell_part.eps	(revision 281)
@@ -3,6 +3,6 @@
 %%Pages: 1
 %%Orientation: Portrait
-%%BoundingBox: 35 275 523 541
-%%HiResBoundingBox: 35.315479 275.24539 522.26021 540.92724
+%%BoundingBox: 35 274 523 537
+%%HiResBoundingBox: 35.315479 274.43741 522.26021 536.89432
 %%EndComments
 %%Page: 1 1
@@ -10,30 +10,4 @@
 0.80000000 -0.80000000 scale
 gsave [1.0000000 0.00000000 0.00000000 1.0000000 0.00000000 0.00000000] concat
-gsave [0.65975900 0.75147700 -0.75147700 0.65975900 0.00000000 0.00000000] concat
-gsave
-0.00000000 1.0000000 0.00000000 setrgbcolor
-newpath
-596.52661 147.99750 moveto
-674.47675 147.99750 lineto
-674.47675 161.34754 lineto
-596.52661 161.34754 lineto
-596.52661 147.99750 lineto
-closepath
-fill
-grestore
-0.00000000 1.0000000 0.00000000 setrgbcolor
-[] 0 setdash
-1.9800013 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-596.52661 147.99750 moveto
-674.47675 147.99750 lineto
-674.47675 161.34754 lineto
-596.52661 161.34754 lineto
-596.52661 147.99750 lineto
-closepath
-stroke
-grestore
 gsave [0.92330700 0.38406300 -0.40401100 0.91475400 0.00000000 0.00000000] concat
 gsave
@@ -66,9 +40,9 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
--156.03575 765.60248 moveto
--97.661018 765.60248 lineto
--97.661018 806.71167 lineto
--156.03575 806.71167 lineto
--156.03575 765.60248 lineto
+-132.50075 734.34601 moveto
+-74.126011 734.34601 lineto
+-74.126011 775.45520 lineto
+-132.50075 775.45520 lineto
+-132.50075 734.34601 lineto
 closepath
 eofill
@@ -76,13 +50,13 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 [] 0 setdash
-1.0000001 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
--156.03575 765.60248 moveto
--97.661018 765.60248 lineto
--97.661018 806.71167 lineto
--156.03575 806.71167 lineto
--156.03575 765.60248 lineto
+1.0000002 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+-132.50075 734.34601 moveto
+-74.126011 734.34601 lineto
+-74.126011 775.45520 lineto
+-132.50075 775.45520 lineto
+-132.50075 734.34601 lineto
 closepath
 stroke
@@ -105,9 +79,9 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
-456.42810 476.06787 moveto
-487.71068 476.06787 lineto
-487.71068 508.69933 lineto
-456.42810 508.69933 lineto
-456.42810 476.06787 lineto
+527.03149 434.68646 moveto
+558.31406 434.68646 lineto
+558.31406 467.31791 lineto
+527.03149 467.31791 lineto
+527.03149 434.68646 lineto
 closepath
 eofill
@@ -115,13 +89,13 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 [] 0 setdash
-0.75914371 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-456.42810 476.06787 moveto
-487.71068 476.06787 lineto
-487.71068 508.69933 lineto
-456.42810 508.69933 lineto
-456.42810 476.06787 lineto
+0.75914353 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+527.03149 434.68646 moveto
+558.31406 434.68646 lineto
+558.31406 467.31791 lineto
+527.03149 467.31791 lineto
+527.03149 434.68646 lineto
 closepath
 stroke
@@ -131,9 +105,9 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
--344.38599 376.22754 moveto
--324.36791 376.22754 lineto
--324.36791 398.24718 lineto
--344.38599 398.24718 lineto
--344.38599 376.22754 lineto
+-377.93018 224.46983 moveto
+-357.91210 224.46983 lineto
+-357.91210 246.48948 lineto
+-377.93018 246.48948 lineto
+-377.93018 224.46983 lineto
 closepath
 eofill
@@ -145,9 +119,9 @@
 0 setlinecap
 newpath
--344.38599 376.22754 moveto
--324.36791 376.22754 lineto
--324.36791 398.24718 lineto
--344.38599 398.24718 lineto
--344.38599 376.22754 lineto
+-377.93018 224.46983 moveto
+-357.91210 224.46983 lineto
+-357.91210 246.48948 lineto
+-377.93018 246.48948 lineto
+-377.93018 224.46983 lineto
 closepath
 stroke
@@ -158,7 +132,7 @@
 newpath
 190.68875 424.80807 moveto
-453.56177 424.80807 lineto
-453.56177 448.68860 lineto
-190.68875 448.68860 lineto
+512.48712 424.80807 lineto
+512.48712 448.75340 lineto
+190.68875 448.75340 lineto
 190.68875 424.80807 lineto
 closepath
@@ -172,7 +146,7 @@
 newpath
 190.68875 424.80807 moveto
-453.56177 424.80807 lineto
-453.56177 448.68860 lineto
-190.68875 448.68860 lineto
+512.48712 424.80807 lineto
+512.48712 448.75340 lineto
+190.68875 448.75340 lineto
 190.68875 424.80807 lineto
 closepath
@@ -183,9 +157,9 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
-2.4339151 475.15820 moveto
-28.936269 475.15820 lineto
-28.936269 492.57411 lineto
-2.4339151 492.57411 lineto
-2.4339151 475.15820 lineto
+-143.69884 380.23199 moveto
+-117.19646 380.23199 lineto
+-117.19646 397.64792 lineto
+-143.69884 397.64792 lineto
+-143.69884 380.23199 lineto
 closepath
 eofill
@@ -193,20 +167,20 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 [] 0 setdash
-1.0000011 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-2.4339151 475.15820 moveto
-28.936269 475.15820 lineto
-28.936269 492.57411 lineto
-2.4339151 492.57411 lineto
-2.4339151 475.15820 lineto
-closepath
-stroke
-grestore
-gsave
-0.00000000 0.00000000 0.00000000 setrgbcolor
-newpath
-484.25220 603.90547 moveto
+1.0000018 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+-143.69884 380.23199 moveto
+-117.19646 380.23199 lineto
+-117.19646 397.64792 lineto
+-143.69884 397.64792 lineto
+-143.69884 380.23199 lineto
+closepath
+stroke
+grestore
+gsave
+0.00000000 0.00000000 0.00000000 setrgbcolor
+newpath
+473.14052 569.56028 moveto
 94.799049 638.75573 lineto
 eofill
@@ -218,8 +192,8 @@
 0 setlinecap
 newpath
-484.25220 603.90547 moveto
+473.14052 569.56028 moveto
 94.799049 638.75573 lineto
 stroke
-gsave [1.1832370 -0.10588210 0.10588210 1.1832370 88.882864 639.28514] concat
+gsave [1.1685816 -0.21372367 0.21372367 1.1685816 88.956141 639.82435] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -236,18 +210,18 @@
 0.00000000 0.00000000 1.0000000 setrgbcolor
 newpath
-485.35699 601.97099 moveto
-294.71457 406.33482 lineto
+473.53439 566.12822 moveto
+120.16402 408.33747 lineto
 eofill
 grestore
 0.00000000 0.00000000 0.00000000 setrgbcolor
 [] 0 setdash
-1.7246197 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-485.35699 601.97099 moveto
-294.71457 406.33482 lineto
-stroke
-gsave [0.72217462 0.74109149 -0.74109149 0.72217462 291.10370 402.62936] concat
+2.3055024 setlinewidth
+0 setlinejoin
+0 setlinecap
+newpath
+473.53439 566.12822 moveto
+120.16402 408.33747 lineto
+stroke
+gsave [1.2630969 0.56401165 -0.56401165 1.2630969 113.84854 405.51741] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -264,6 +238,6 @@
 0.00000000 0.00000000 0.00000000 setrgbcolor
 newpath
-485.72819 599.38017 moveto
-334.24442 405.39011 lineto
+477.14189 563.01467 moveto
+196.86368 406.40027 lineto
 eofill
 grestore
@@ -274,8 +248,8 @@
 0 setlinecap
 newpath
-485.72819 599.38017 moveto
-334.24442 405.39011 lineto
-stroke
-gsave [0.68831432 0.88145507 -0.88145507 0.68831432 330.80285 400.98283] concat
+477.14189 563.01467 moveto
+196.86368 406.40027 lineto
+stroke
+gsave [0.97628648 0.54553125 -0.54553125 0.97628648 191.98225 403.67261] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -1028,35 +1002,9 @@
 651.41276 431.16939 lineto
 stroke
-gsave [0.74322500 0.66904200 -0.66904200 0.74322500 0.00000000 0.00000000] concat
-gsave
-0.00000000 1.0000000 0.00000000 setrgbcolor
-newpath
-517.90771 149.53259 moveto
-695.34373 149.53259 lineto
-695.34373 161.73132 lineto
-517.90771 161.73132 lineto
-517.90771 149.53259 lineto
-closepath
-fill
-grestore
-0.00000000 1.0000000 0.00000000 setrgbcolor
-[] 0 setdash
-2.1927264 setlinewidth
-0 setlinejoin
-0 setlinecap
-newpath
-517.90771 149.53259 moveto
-695.34373 149.53259 lineto
-695.34373 161.73132 lineto
-517.90771 161.73132 lineto
-517.90771 149.53259 lineto
-closepath
-stroke
-grestore
 gsave
 1.0000000 0.00000000 0.00000000 setrgbcolor
 newpath
-352.91269 418.03740 moveto
-270.08018 687.74813 lineto
+411.50154 424.60339 moveto
+331.19441 688.25321 lineto
 eofill
 grestore
@@ -1067,6 +1015,6 @@
 0 setlinecap
 newpath
-352.91269 418.03740 moveto
-270.08018 687.74813 lineto
+411.50154 424.60339 moveto
+331.19441 688.25321 lineto
 stroke
 0.00000000 0.00000000 0.00000000 setrgbcolor
@@ -1076,8 +1024,8 @@
 0 setlinecap
 newpath
-480.32753 607.38999 moveto
-190.41376 670.52452 lineto
-stroke
-gsave [1.1607942 -0.25278619 0.25278619 1.1607942 184.60979 671.78845] concat
+471.23616 574.05496 moveto
+264.65997 667.99914 lineto
+stroke
+gsave [1.0814248 -0.49179709 0.49179709 1.0814248 259.25285 670.45813] concat
 gsave
 0.00000000 0.00000000 0.00000000 setrgbcolor