Index: trunk/VUT/doc/SciReport/figs/approximate_sampling.fig
===================================================================
--- trunk/VUT/doc/SciReport/figs/approximate_sampling.fig	(revision 282)
+++ trunk/VUT/doc/SciReport/figs/approximate_sampling.fig	(revision 282)
@@ -0,0 +1,33 @@
+#FIG 3.2
+Landscape
+Center
+Inches
+Letter  
+100.00
+Single
+-2
+1200 2
+5 1 0 1 0 7 54 -1 -1 0.000 0 0 0 0 5362.500 2437.500 6075 2100 6150 2475 6075 2775
+1 3 0 2 0 4 48 -1 20 0.000 1 0.0000 2400 2475 106 106 2400 2475 2506 2475
+1 3 0 2 0 7 50 -1 14 0.000 1 0.0000 7875 1875 691 691 7875 1875 8566 1875
+1 3 0 2 0 7 50 -1 14 0.000 1 0.0000 8274 2957 370 370 8274 2957 8625 3075
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 2400 2475 9300 2100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 2400 3300 9300 2625
+2 1 0 1 0 7 54 -1 -1 0.000 0 0 -1 0 0 2
+	 2400 2475 12075 1950
+2 1 0 1 0 7 54 -1 -1 0.000 0 0 7 0 0 2
+	 2400 2475 12225 2700
+2 1 0 10 4 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 9300 2100 9300 2625
+2 2 0 3 0 11 59 -1 20 0.000 0 0 -1 0 0 5
+	 -450 1500 2400 1500 2400 4200 -450 4200 -450 1500
+2 2 0 3 0 11 59 -1 20 0.000 0 0 7 0 0 5
+	 9300 1725 11550 1725 11550 3975 9300 3975 9300 1725
+2 1 0 0 0 6 62 -1 20 0.000 0 0 -1 0 0 5
+	 2400 2475 2400 3300 9300 2625 9300 2100 2400 2475
+4 0 0 54 -1 0 32 0.0000 4 330 1650 150 2925 view cell\001
+4 0 0 54 -1 0 32 0.0000 4 435 1125 9600 3450 object\001
+4 0 0 59 -1 0 32 0.0000 4 330 1800 6825 825 occluders\001
+4 0 0 54 -1 32 36 0.0000 4 285 345 6450 2550 a\001
Index: trunk/VUT/doc/SciReport/figs/conservative_sampling.fig
===================================================================
--- trunk/VUT/doc/SciReport/figs/conservative_sampling.fig	(revision 282)
+++ trunk/VUT/doc/SciReport/figs/conservative_sampling.fig	(revision 282)
@@ -0,0 +1,47 @@
+#FIG 3.2
+Landscape
+Center
+Inches
+Letter  
+100.00
+Single
+-2
+1200 2
+1 3 0 2 0 7 50 -1 14 0.000 1 0.0000 5325 1800 437 437 5325 1800 5762 1800
+1 3 0 2 0 7 50 -1 14 0.000 1 0.0000 3675 2100 375 375 3675 2100 3975 2325
+1 3 0 2 0 7 50 -1 14 0.000 1 0.0000 3225 3075 375 375 3225 3075 3525 3300
+1 3 0 2 0 7 50 -1 14 0.000 1 0.0000 5325 3225 424 424 5325 3225 5625 3525
+1 3 0 2 0 4 50 -1 20 0.000 1 0.0000 4500 2700 237 237 4500 2700 4737 2700
+2 2 0 3 0 11 50 -1 20 0.000 0 0 -1 0 0 5
+	 1200 2100 2400 2100 2400 3300 1200 3300 1200 2100
+2 2 0 3 0 11 50 -1 20 0.000 0 0 7 0 0 5
+	 6600 2100 7800 2100 7800 3300 6600 3300 6600 2100
+2 1 0 0 0 6 55 -1 20 0.000 0 0 -1 0 0 5
+	 2400 2100 2400 2400 6600 3300 6600 3000 2475 2100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 1 2
+	1 1 1.00 60.00 120.00
+	1 1 1.00 60.00 120.00
+	 2400 2100 6600 2100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 7 1 1 2
+	1 1 1.00 60.00 120.00
+	1 1 1.00 60.00 120.00
+	 2400 2100 6600 2700
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 7 1 1 2
+	1 1 1.00 60.00 120.00
+	1 1 1.00 60.00 120.00
+	 2400 2400 6600 3300
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 7 1 1 2
+	1 1 1.00 60.00 120.00
+	1 1 1.00 60.00 120.00
+	 2475 2100 6600 3000
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 7 1 1 2
+	1 1 1.00 60.00 120.00
+	1 1 1.00 60.00 120.00
+	 2400 2700 6600 3300
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 7 1 1 2
+	1 1 1.00 60.00 120.00
+	1 1 1.00 60.00 120.00
+	 2400 3300 6600 3300
+4 0 0 50 -1 0 18 0.0000 4 195 960 1350 2775 view cell\001
+4 0 0 50 -1 0 18 0.0000 4 255 675 6900 2700 object\001
+4 0 0 50 -1 0 18 0.0000 4 195 1050 3900 1350 occluders\001
Index: trunk/VUT/doc/SciReport/mutual.tex
===================================================================
--- trunk/VUT/doc/SciReport/mutual.tex	(revision 277)
+++ trunk/VUT/doc/SciReport/mutual.tex	(revision 282)
@@ -401,5 +401,18 @@
 If the subdivision does not terminate till reaching a predefined
 subdivision depth, we conservatively classify the tested regions as
-mutually visible.
+mutually visible. The conservative verifier is illustrated at
+Figure~\ref{fig:conservative_sampling}.
+
+\begin{figure}[htb]
+\centerline{
+\includegraphics[width=0.7\textwidth,draft=\DRAFTFIGS]{figs/conservative_sampling}}
+\caption{An example of the conservative visibility verification. The figure shows two
+  tested regions (the view cell and the object) and several
+  occluders. For sake of clarity we only show samples which are
+  boundaries of shafts on one path of the line space subdivision tree.
+  The subdivision terminates at the yellow shaft since a single strong
+  occluder has been found. }
+\label{fig:conservative_sampling}
+\end{figure}
 
 
@@ -409,18 +422,29 @@
 conservative one. However it will behave differently in the finer
 subdivision of the ray shafts. The idea is to use the above algorithm
-as far as the shafts get small enough that we can guarantee that even
-if the shaft is not blocked by the scene objects, a pixel error
-induced due to omission of objects potential visible behind the shaft
-is bellow a given threshold.
+as far as the shafts get small enough that we can neglect objects
+which can be seen through such a shaft. Even if not all rays inside
+the shaft are not blocked by scene objects, a pixel error induced due
+to omission of objects potential visible behind the shaft will be
+bellow a given threshold.
 
 For the computation of the maximal error due to the current shaft we
 assume that one tested region is a view cell, whereas the other is an
 object bounding box or cell of the spatial hierarchy. The threshold is
-computed as follows: We first triangulate the farthest intersection
-points in the shaft as seen from the view cell side of the shaft. Then
-for each computed triangle we calculate a point in the view cell which
-maximizes the projected area of the triangle. The conservative
-estimate of the maximal error is then given by a sum of the computed
-projected areas.
+computed as follows: We calculate a point in the view cell which
+maximizes the projected area of the object with respect to the shaft
+(see Figure~\ref{fig:approximate_sampling}). The conservative estimate
+of the maximal error is then given by the computed projected area. If
+this error is below a specified threshold we terminate the subdivision
+of the current shaft.
+
+\begin{figure}[htb]
+\centerline{
+\includegraphics[width=0.7\textwidth,draft=\DRAFTFIGS]{figs/approximate_sampling}}
+\caption{An example of the approximate error bound visibility verification. The figure shows two
+  tested regions (the view cell and the object) and two
+  occluders. The maximal error inside the yellow shaft corresponds to the angle $\alpha$.
+}
+\label{fig:approximate_sampling}
+\end{figure}
 
 %Option: - if there is sufficient number of samples from 1 + 2 and some
Index: trunk/VUT/doc/SciReport/sampling.tex
===================================================================
--- trunk/VUT/doc/SciReport/sampling.tex	(revision 279)
+++ trunk/VUT/doc/SciReport/sampling.tex	(revision 282)
@@ -490,7 +490,8 @@
 are planar planes whereas the EEE are in general quadratic surfaces.
 
- To account for these event we explicitly place samples passing by the
-object edges which are directed to edges and/or vertices of other
-objects.
+ To account for these events we explicitly place samples passing by
+the object edges which are directed to edges and/or vertices of other
+objects. In this way we perform stochastic sampling at boundaries of
+the visibility complex~\cite{Durand:1996:VCN}.
 
 The first strategy starts similarly to the above described sampling
@@ -499,5 +500,5 @@
 connectivity information we select a random silhouette edge from this
 object and cast a sample which is tangent to that object at the
-selected edge .
+selected edge.
 
 The second strategy works as follows: we randomly pickup two objects