Index: trunk/VUT/doc/SciReport/analysis.tex
===================================================================
--- trunk/VUT/doc/SciReport/analysis.tex	(revision 277)
+++ trunk/VUT/doc/SciReport/analysis.tex	(revision 283)
@@ -54,5 +54,5 @@
 coordinates of 2D lines defined in this chapter are a simplified form
 of the \plucker coordinates for 3D lines, which will be discussed
-bellow in this chapter: \plucker coordinates of a 2D line correspond
+below in this chapter: \plucker coordinates of a 2D line correspond
 to the \plucker coordinates of a 3D line embedded in the $z = 0$ plane
 after removal of redundant coordinates (equal to 0) and permutation of
Index: trunk/VUT/doc/SciReport/figs/latency.eps
===================================================================
--- trunk/VUT/doc/SciReport/figs/latency.eps	(revision 272)
+++ trunk/VUT/doc/SciReport/figs/latency.eps	(revision 283)
@@ -2,5 +2,5 @@
 %%Title: latency.fig
 %%Creator: fig2dev Version 3.2 Patchlevel 4
-%%CreationDate: Thu Sep 15 12:53:15 2005
+%%CreationDate: Fri Sep 16 18:25:55 2005
 %%For: matt@sakura (matt,U-COMPUTERGRAPHIK\matt,S-1-5-21-1259991482-2646404242-2158041560-3508)
 %%BoundingBox: 0 0 1153 326
Index: trunk/VUT/doc/SciReport/figs/dummy.eps
===================================================================
--- trunk/VUT/doc/SciReport/figs/dummy.eps	(revision 272)
+++ trunk/VUT/doc/SciReport/figs/dummy.eps	(revision 283)
@@ -2,5 +2,5 @@
 %%Title: dummy.fig
 %%Creator: fig2dev Version 3.2 Patchlevel 4
-%%CreationDate: Thu Sep 15 12:53:14 2005
+%%CreationDate: Fri Sep 16 18:25:53 2005
 %%For: matt@sakura (matt,U-COMPUTERGRAPHIK\matt,S-1-5-21-1259991482-2646404242-2158041560-3508)
 %%BoundingBox: 0 0 474 443
Index: trunk/VUT/doc/SciReport/figs/cut.eps
===================================================================
--- trunk/VUT/doc/SciReport/figs/cut.eps	(revision 272)
+++ trunk/VUT/doc/SciReport/figs/cut.eps	(revision 283)
@@ -2,5 +2,5 @@
 %%Title: cut.fig
 %%Creator: fig2dev Version 3.2 Patchlevel 4
-%%CreationDate: Thu Sep 15 12:53:13 2005
+%%CreationDate: Fri Sep 16 18:25:52 2005
 %%For: matt@sakura (matt,U-COMPUTERGRAPHIK\matt,S-1-5-21-1259991482-2646404242-2158041560-3508)
 %%BoundingBox: 0 0 979 330
Index: trunk/VUT/doc/SciReport/figs/latency2.eps
===================================================================
--- trunk/VUT/doc/SciReport/figs/latency2.eps	(revision 272)
+++ trunk/VUT/doc/SciReport/figs/latency2.eps	(revision 283)
@@ -2,5 +2,5 @@
 %%Title: latency2.fig
 %%Creator: fig2dev Version 3.2 Patchlevel 4
-%%CreationDate: Thu Sep 15 12:53:16 2005
+%%CreationDate: Fri Sep 16 18:25:55 2005
 %%For: matt@sakura (matt,U-COMPUTERGRAPHIK\matt,S-1-5-21-1259991482-2646404242-2158041560-3508)
 %%BoundingBox: 0 0 992 393
Index: trunk/VUT/doc/SciReport/figs/basic.eps
===================================================================
--- trunk/VUT/doc/SciReport/figs/basic.eps	(revision 272)
+++ trunk/VUT/doc/SciReport/figs/basic.eps	(revision 283)
@@ -2,5 +2,5 @@
 %%Title: basic.fig
 %%Creator: fig2dev Version 3.2 Patchlevel 4
-%%CreationDate: Thu Sep 15 12:53:12 2005
+%%CreationDate: Fri Sep 16 18:25:50 2005
 %%For: matt@sakura (matt,U-COMPUTERGRAPHIK\matt,S-1-5-21-1259991482-2646404242-2158041560-3508)
 %%BoundingBox: 0 0 793 244
Index: trunk/VUT/doc/SciReport/mutual.tex
===================================================================
--- trunk/VUT/doc/SciReport/mutual.tex	(revision 282)
+++ trunk/VUT/doc/SciReport/mutual.tex	(revision 283)
@@ -426,5 +426,5 @@
 the shaft are not blocked by scene objects, a pixel error induced due
 to omission of objects potential visible behind the shaft will be
-bellow a given threshold.
+below a given threshold.
 
 For the computation of the maximal error due to the current shaft we
Index: trunk/VUT/doc/SciReport/sampling.tex
===================================================================
--- trunk/VUT/doc/SciReport/sampling.tex	(revision 282)
+++ trunk/VUT/doc/SciReport/sampling.tex	(revision 283)
@@ -14,5 +14,5 @@
 can be easily integrated into the game development cycle. The
 aggressive sampling will terminate when the average contribution of new
-ray samples falls bellow a predefined threshold.
+ray samples falls below a predefined threshold.
 
 \item The second step is mutual visibility verification. This step
@@ -461,5 +461,5 @@
 cells to the terminating object. Thus as the ray samples are cast we
 can measure the average contribution of a certain number of most
-recent samples.  If this contribution falls bellow a predefined
+recent samples.  If this contribution falls below a predefined
 constant we move on to the next sampling strategy, which aim to
 discover more complicated visibility relations.